"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var errors_1 = require("./errors");
// eslint-disable-next-line @typescript-eslint/no-var-requires
var detectIndent = require("detect-indent");
var default_1 = /** @class */ (function () {
    function default_1(path) {
        this.path = path;
        this.fileContents = fs_1.default.readFileSync(path, "utf-8");
        if (!this.fileContents) {
            throw new errors_1.PackageFileNotFoundError(path);
        }
        var fileParsed = JSON.parse(this.fileContents);
        if (!fileParsed.scripts) {
            fileParsed.scripts = {};
        }
        this.package = fileParsed;
        this.indent = detectIndent(this.fileContents);
    }
    default_1.prototype.get = function () {
        return this.package;
    };
    default_1.prototype.set = function (path, content) {
        this.package[path] = content;
        return this;
    };
    default_1.prototype.save = function () {
        var json = JSON.stringify(this.package, null, this.indent.indent);
        return fs_1.default.writeFileSync(this.path, json);
    };
    return default_1;
}());
exports.default = default_1;
