"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadRulesFromRuleConfig = exports.getRuleByName = void 0;
var defaultRuleSets_1 = __importDefault(require("./defaultRuleSets"));
var rules_1 = __importDefault(require("./rules"));
var getRuleByName = function (rules, name) {
    var filtered = rules.filter(function (r) { return r.name === name; });
    if (filtered.length < 1) {
        return null;
    }
    return filtered[0];
};
exports.getRuleByName = getRuleByName;
var loadDefaultRulesFromSet = function (strict) {
    if (strict) {
        return defaultRuleSets_1.default.strict
            .map(function (name) { return exports.getRuleByName(rules_1.default, name); })
            .filter(function (r) { return r !== null; });
    }
    return defaultRuleSets_1.default.default
        .map(function (name) { return exports.getRuleByName(rules_1.default, name); })
        .filter(function (r) { return r !== null; });
};
var loadRulesFromRuleConfig = function (strict, rulesConfig, customRules) {
    var rules = loadDefaultRulesFromSet(strict);
    var loadedCustomRules = rulesConfig && customRules
        ? customRules.filter(function (cr) { return rulesConfig[cr.name]; })
        : [];
    var loadedRules = __spreadArray(__spreadArray([], loadedCustomRules), rules);
    if (!rulesConfig) {
        return loadedRules;
    }
    return loadedRules
        .map(function (rule) {
        if (rule.name in rulesConfig && rulesConfig[rule.name] === false) {
            return null;
        }
        return rule;
    })
        .filter(function (r) { return r !== null; });
};
exports.loadRulesFromRuleConfig = loadRulesFromRuleConfig;
