"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sortScripts = void 0;
var sortScripts = function (scripts) {
    return Object.entries(scripts)
        .sort(function (a, b) {
        return a < b ? -1 : 1;
    })
        .reduce(function (r, _a) {
        var _b;
        var k = _a[0], v = _a[1];
        return (__assign(__assign({}, r), (_b = {}, _b[k] = v, _b)));
    }, {});
};
exports.sortScripts = sortScripts;
exports.default = {
    name: "alphabetic-order",
    isObjectRule: true,
    message: "scripts must be in alphabetic order",
    validate: function (scripts) {
        var sorted = exports.sortScripts(scripts);
        return Object.keys(sorted).join("|") === Object.keys(scripts).join("|");
    },
    fix: function (scripts) { return exports.sortScripts(scripts); },
};
