"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mandatoryScriptFactory_1 = __importDefault(require("./mandatoryScriptFactory"));
var noShellSpecificsFactory_1 = __importDefault(require("./noShellSpecificsFactory"));
var no_default_test_1 = __importDefault(require("./no-default-test"));
var correct_casing_1 = __importDefault(require("./correct-casing"));
var no_aliases_1 = __importDefault(require("./no-aliases"));
var prepost_trigger_defined_1 = __importDefault(require("./prepost-trigger-defined"));
var uses_allowed_namespace_1 = __importDefault(require("./uses-allowed-namespace"));
var alphabetic_order_1 = __importDefault(require("./alphabetic-order"));
var rules = [
    mandatoryScriptFactory_1.default("test"),
    mandatoryScriptFactory_1.default("start"),
    mandatoryScriptFactory_1.default("dev"),
    no_default_test_1.default,
    correct_casing_1.default,
    no_aliases_1.default,
    uses_allowed_namespace_1.default,
    prepost_trigger_defined_1.default,
    alphabetic_order_1.default,
    noShellSpecificsFactory_1.default(/rm /, "rm -rf", "rimraf"),
    noShellSpecificsFactory_1.default(/ && /, "unix double ampersand (&&)", "npm-run-all/run-s"),
    noShellSpecificsFactory_1.default(/ & /, "unix single ampersand (&)", "npm-run-all/run-p"),
];
exports.default = rules;
