"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../utils");
exports.default = (function (regex, name, alternative) {
    var slug = utils_1.slugify(name);
    return {
        name: "no-" + slug,
        isObjectRule: false,
        message: "Use of " + name + " in script '{{name}}' is not allowed, consider using " + alternative,
        validate: function (_, script) {
            return !regex.test(script);
        },
    };
});
