"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../constants");
var utils_1 = require("../utils");
var getMissingHooks = function (prefix, scripts) {
    var keys = Object.keys(scripts);
    var hooks = keys.filter(function (k) { return k.startsWith(prefix); });
    var hooksMissing = [];
    hooks.forEach(function (hookName) {
        var triggerName = hookName.substr(prefix.length);
        if (!keys.includes(triggerName)) {
            hooksMissing.push(triggerName);
        }
    });
    return hooksMissing;
};
exports.default = {
    name: "prepost-trigger-defined",
    isObjectRule: true,
    message: "some custom hooks ({{names}}) are missing their trigger script(s)",
    validate: function (scripts) {
        scripts = utils_1.filterPackageScriptsByKeys(scripts, constants_1.DEFAULT_NPM_HOOKS);
        var preHooksMissing = getMissingHooks("pre", scripts);
        var postHooksMissing = getMissingHooks("post", scripts);
        var allMissing = __spreadArray(__spreadArray([], preHooksMissing.map(function (s) { return "pre" + s; })), postHooksMissing.map(function (s) { return "post" + s; }));
        return allMissing.length < 1 ? true : allMissing;
    },
};
