"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var constants_1 = require("../constants");
var validate = function (key) {
    return constants_1.NAMESPACES.some(function (n) { return key === n; }) ||
        constants_1.NAMESPACES.some(function (n) { return key.startsWith(n + ":"); }) ||
        constants_1.DEFAULT_NPM_HOOKS.includes(key) ||
        (key.startsWith("pre") && validate(key.slice(3))) ||
        (key.startsWith("post") && validate(key.slice(4)));
};
exports.default = {
    name: "uses-allowed-namespace",
    isObjectRule: false,
    message: 'script name "{{name}}" should start with one of the allowed namespaces',
    validate: validate,
    fix: function (key, value) { return ["other:" + key, value]; },
};
