"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sanitizeConfig = void 0;
var cosmiconfig_1 = require("cosmiconfig");
var constants_1 = require("./constants");
var errors_1 = require("./errors");
var sanitizeConfig = function (loadedConfig) {
    var sanitized = __assign(__assign({}, constants_1.DEFAULT_CONFIG), loadedConfig);
    Object.keys(sanitized).forEach(function (key) {
        var keyExists = Object.keys(constants_1.DEFAULT_CONFIG).includes(key);
        if (!keyExists) {
            // eslint-disable-next-line @typescript-eslint/no-dynamic-delete
            delete sanitized[key];
            throw new errors_1.ConfigError("unknown config key \"" + key + "\"");
        }
    });
    // eslint-disable-next-line @typescript-eslint/no-unsafe-return
    return sanitized;
};
exports.sanitizeConfig = sanitizeConfig;
var loadConfig = function (name) {
    if (name === void 0) { name = constants_1.PROJECT_NAME; }
    var explorerSync = cosmiconfig_1.cosmiconfigSync(name);
    var searchedFor = explorerSync.search();
    if (!searchedFor) {
        return constants_1.DEFAULT_CONFIG;
    }
    return exports.sanitizeConfig(searchedFor.config);
};
exports.default = loadConfig;
